Index: palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- palm/trunk/SOURCE/check_parameters.f90	(revision 2270)
+++ palm/trunk/SOURCE/check_parameters.f90	(revision 2271)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! roughness-length check altered
+! Error messages fixed
+! 
+! 2270 2017-06-09 12:18:47Z maronga
 ! Revised numbering (removed 2 timeseries)
 ! 
@@ -723,6 +727,6 @@
              WRITE( message_string, * ) 'coupling mode "',                     &
                    TRIM( coupling_mode ),                                      &
-             '": nx+1 in ocean is not divisible without remainder with nx+1 in', & 
-             ' atmosphere'
+             '": nx+1 in ocean is not divisible by nx+1 in', & 
+             ' atmosphere without remainder'
              CALL message( 'check_parameters', 'PA0339', 1, 2, 0, 6, 0 )
           ENDIF
@@ -731,6 +735,7 @@
              WRITE( message_string, * ) 'coupling mode "',                     &
                    TRIM( coupling_mode ),                                      &
-             '": ny+1 in ocean is not divisible without remainder with ny+1 in', & 
-             ' atmosphere'
+             '": ny+1 in ocean is not divisible by ny+1 in', & 
+             ' atmosphere without remainder'
+
              CALL message( 'check_parameters', 'PA0340', 1, 2, 0, 6, 0 )
           ENDIF
@@ -1183,5 +1188,5 @@
          conserve_volume_flow ) THEN
          message_string = 'initializing_actions = "initialize_vortex"' //      &
-                        ' ist not allowed with conserve_volume_flow = .T.'
+                        ' is not allowed with conserve_volume_flow = .T.'
        CALL message( 'check_parameters', 'PA0343', 1, 2, 0, 6, 0 )
     ENDIF       
@@ -3976,5 +3981,5 @@
     IF ( ( constant_flux_layer .OR.  &
            INDEX( initializing_actions, 'set_1d-model_profiles' ) /= 0 ) &
-         .AND. roughness_length > 0.5 * dz )  THEN
+         .AND. roughness_length >= 0.5 * dz )  THEN
        message_string = 'roughness_length must be smaller than dz/2'
        CALL message( 'check_parameters', 'PA0424', 1, 2, 0, 6, 0 )
Index: palm/trunk/SOURCE/init_masks.f90
===================================================================
--- palm/trunk/SOURCE/init_masks.f90	(revision 2270)
+++ palm/trunk/SOURCE/init_masks.f90	(revision 2271)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Changed error message
+! 
+! 2101 2017-01-05 16:42:31Z suehring
 !
 ! 2031 2016-10-21 15:11:58Z knoop
@@ -688,5 +691,5 @@
                      '.&Vertical mask locations will not ', &
                      'match the desired heights&within the stretching ', &
-                     'region. Recommendation: use mask instead of mask_loop.'
+                     'region.'
                 CALL message( 'init_masks', 'PA0334', 0, 1, 0, 6, 0 )
              ENDIF
Index: palm/trunk/SOURCE/init_pegrid.f90
===================================================================
--- palm/trunk/SOURCE/init_pegrid.f90	(revision 2270)
+++ palm/trunk/SOURCE/init_pegrid.f90	(revision 2271)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Error message changed
+! 
+! 2259 2017-06-08 09:09:11Z gronemeier
 ! Implemented synthetic turbulence generator
 !
@@ -938,5 +941,5 @@
                   mg_switch_to_pe0_level >= maximum_grid_level_l )  THEN
                 message_string = 'mg_switch_to_pe0_level ' // &
-                                 'out of range and reset to default (=0)'
+                                 'out of range and reset to 0'
                 CALL message( 'init_pegrid', 'PA0235', 0, 1, 0, 6, 0 )
                 mg_switch_to_pe0_level = 0
Index: palm/trunk/SOURCE/ls_forcing_mod.f90
===================================================================
--- palm/trunk/SOURCE/ls_forcing_mod.f90	(revision 2270)
+++ palm/trunk/SOURCE/ls_forcing_mod.f90	(revision 2271)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Error messages changed
+! 
+! 2233 2017-05-30 18:08:54Z suehring
 !
 ! 2232 2017-05-30 17:47:52Z suehring
@@ -229,7 +232,7 @@
 
        IF ( time_surf(1) > end_time )  THEN
-          WRITE ( message_string, * ) 'No time dependent surface variables in ',&
-                                     '&LSF_DATA for end of run found - ',      &
-                                     'lsf_surf is set to FALSE'
+          WRITE ( message_string, * ) 'Time dependent surface variables in ',  &
+                                      '&LSF_DATA set in after end of ' ,      &
+                                      'simulation - lsf_surf is set to FALSE'
           CALL message( 'ls_forcing', 'PA0371', 0, 0, 0, 6, 0 )
           lsf_surf = .FALSE.
@@ -303,5 +306,5 @@
 
                 IF ( ierrn /= 0 )  THEN
-                   WRITE( message_string, * ) 'zu(nzt+1) = ', zu(nzt+1), 'm ', &
+                   WRITE( message_string, * ) 'zu(',k,') = ', zu(k), 'm ', &
                         'is higher than the maximum height in LSF_DATA which ',&
                         'is ', lowheight, 'm. Interpolation on PALM ',         &
Index: palm/trunk/SOURCE/nudging_mod.f90
===================================================================
--- palm/trunk/SOURCE/nudging_mod.f90	(revision 2270)
+++ palm/trunk/SOURCE/nudging_mod.f90	(revision 2271)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Error message changed
+! 
+! 2233 2017-05-30 18:08:54Z suehring
 !
 ! 2232 2017-05-30 17:47:52Z suehring
@@ -238,5 +241,5 @@
                                                   highqnudge
                 IF (ierrn /= 0 )  THEN
-                   WRITE( message_string, * ) 'zu(nzt+1) = ', zu(nzt+1), 'm is ',&
+                   WRITE( message_string, * ) 'zu(',k,') = ', zu(k), 'm is ',&
                         'higher than the maximum height in NUDING_DATA which ',  &
                         'is ', lowheight, 'm. Interpolation on PALM ',           &
Index: palm/trunk/SOURCE/pmc_handle_communicator_mod.f90
===================================================================
--- palm/trunk/SOURCE/pmc_handle_communicator_mod.f90	(revision 2270)
+++ palm/trunk/SOURCE/pmc_handle_communicator_mod.f90	(revision 2271)
@@ -26,4 +26,7 @@
 ! -----------------
 ! $Id$
+! Error message text changed
+! 
+! 2101 2017-01-05 16:42:31Z suehring
 !
 ! 2013 2016-09-21 13:07:56Z suehring
@@ -536,6 +539,7 @@
        ENDDO
        IF ( bad_llcorner /= 0)  THEN
-          WRITE ( message_string, *)  'lower left corners do not match,',       &
-                                      'they were set to (0, 0)'
+          WRITE ( message_string, *)  'at least one dimension of lower ',       &
+		                      'left corner of one domain is not 0. ',   &
+                                      'All lower left corners were set to (0, 0)'
           CALL message( 'read_coupling_layout', 'PA0427', 0, 0, 0, 6, 0 )
        ENDIF
Index: palm/trunk/SOURCE/time_integration.f90
===================================================================
--- palm/trunk/SOURCE/time_integration.f90	(revision 2270)
+++ palm/trunk/SOURCE/time_integration.f90	(revision 2271)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Start timestep message changed
+! 
+! 2259 2017-06-08 09:09:11Z gronemeier
 ! Implemented synthetic turbulence generator
 !
@@ -438,5 +441,5 @@
 #endif
 
-    CALL location_message( 'start with time-stepping', .TRUE. )
+    CALL location_message( 'starting timestep-sequence', .TRUE. )
 !
 !-- Start of the time loop
Index: palm/trunk/SOURCE/user_define_netcdf_grid.f90
===================================================================
--- palm/trunk/SOURCE/user_define_netcdf_grid.f90	(revision 2270)
+++ palm/trunk/SOURCE/user_define_netcdf_grid.f90	(revision 2271)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! found = .TRUE. added to grid definition in examples to avoid warning message
+! 
+! 2101 2017-01-05 16:42:31Z suehring
 !
 ! 2000 2016-08-20 18:09:15Z knoop
@@ -70,4 +73,5 @@
 !--    Uncomment and extend the following lines, if necessary
 !       CASE ( 'u2', 'u2_xy', 'u2_xz', 'u2_yz' )
+!          found  = .TRUE.
 !          grid_x = 'xu'
 !          grid_y = 'y'
@@ -75,4 +79,5 @@
 
 !       CASE ( 'u*v*', 'u*v*_xy', 'u*v*_xz', 'u*v*_yz' )
+!          found  = .TRUE.
 !          grid_x = 'x'
 !          grid_y = 'y'
Index: palm/trunk/SOURCE/virtual_flight_mod.f90
===================================================================
--- palm/trunk/SOURCE/virtual_flight_mod.f90	(revision 2270)
+++ palm/trunk/SOURCE/virtual_flight_mod.f90	(revision 2271)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Todo added
+! 
+! 2101 2017-01-05 16:42:31Z suehring
 !
 ! 2000 2016-08-20 18:09:15Z knoop
@@ -39,4 +42,5 @@
 ! ------------
 !> Module for virtual flight measurements.
+!> @todo Err msg PA0438: flight can be inside topography -> extra check?
 !--------------------------------------------------------------------------------!
  MODULE flight_mod