Index: /palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- /palm/trunk/SOURCE/check_parameters.f90	(revision 2273)
+++ /palm/trunk/SOURCE/check_parameters.f90	(revision 2274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Changed error messages 
+! 
+! 2271 2017-06-09 12:34:55Z sward
 ! roughness-length check altered
 ! Error messages fixed
@@ -957,14 +960,7 @@
 !
 !-- Check ocean setting
-    IF ( ocean )  THEN
-
-       action = ' '
-       IF ( action /= ' ' )  THEN
-          message_string = 'ocean = .T. does not allow ' // TRIM( action )
-          CALL message( 'check_parameters', 'PA0015', 1, 2, 0, 6, 0 )
-       ENDIF
-
-    ELSEIF ( TRIM( coupling_mode ) == 'uncoupled'  .AND.                       &
-             TRIM( coupling_char ) == '_O' )  THEN
+    IF ( TRIM( coupling_mode ) == 'uncoupled'  .AND.                           &
+         TRIM( coupling_char ) == '_O' .AND.                                   &
+         .NOT. ocean )  THEN
 
 !
@@ -1072,5 +1068,5 @@
        )  THEN
        use_upstream_for_tke = .TRUE.
-       message_string = 'use_upstream_for_tke set .TRUE. because ' //          &
+       message_string = 'use_upstream_for_tke is set to .TRUE. because ' //    &
                         'use_sgs_for_particles = .TRUE. '          //          &
                         'and scalar_advec /= ws-scheme'
@@ -1173,5 +1169,5 @@
 
              CASE ( 'set_constant_profiles', 'set_1d-model_profiles',          &
-                    'by_user', 'initialize_vortex',     'initialize_ptanom' )
+                    'by_user', 'initialize_vortex', 'initialize_ptanom' )
                 action = action(position+1:)
 
@@ -3503,5 +3499,5 @@
     IF ( bc_lr /= 'cyclic' ) THEN
        IF ( pt_damping_width < 0.0_wp  .OR.                                    &
-            pt_damping_width > REAL( nx * dx ) )  THEN
+            pt_damping_width > REAL( (nx+1) * dx ) )  THEN
           message_string = 'pt_damping_width out of range'
           CALL message( 'check_parameters', 'PA0124', 1, 2, 0, 6, 0 )
@@ -3511,5 +3507,5 @@
     IF ( bc_ns /= 'cyclic' )  THEN
        IF ( pt_damping_width < 0.0_wp  .OR.                                    &
-            pt_damping_width > REAL( ny * dy ) )  THEN
+            pt_damping_width > REAL( (ny+1) * dy ) )  THEN
           message_string = 'pt_damping_width out of range'
           CALL message( 'check_parameters', 'PA0124', 1, 2, 0, 6, 0 )
@@ -3594,6 +3590,6 @@
     IF ( disturbance_level_ind_t < disturbance_level_ind_b )  THEN
        WRITE( message_string, * )  'disturbance_level_ind_t = ',               &
-                disturbance_level_ind_t, ' must be >= disturbance_level_b = ', &
-                disturbance_level_b
+                disturbance_level_ind_t, ' must be >= disturbance_level_ind_b = ', &
+                disturbance_level_ind_b
        CALL message( 'check_parameters', 'PA0130', 1, 2, 0, 6, 0 )
     ENDIF
@@ -3696,5 +3692,6 @@
          initializing_actions /= 'read_restart_data' )  THEN
        message_string = 'turbulent_inflow = .T. requires ' //                  &
-                        'initializing_actions = ''cyclic_fill'' '
+                        'initializing_actions = ''cyclic_fill'' or ' //        &
+                        'initializing_actions = ''read_restart_data'' '
        CALL message( 'check_parameters', 'PA0055', 1, 2, 0, 6, 0 )
     ENDIF
@@ -3703,5 +3700,5 @@
 !-- In case of turbulent inflow calculate the index of the recycling plane
     IF ( turbulent_inflow )  THEN
-       IF ( recycling_width < dx  .OR.  recycling_width > nx * dx )  THEN
+       IF ( recycling_width <= dx  .OR.  recycling_width >= nx * dx )  THEN
           WRITE( message_string, * )  'illegal value for recycling_width:', &
                                       ' ', recycling_width
@@ -3749,5 +3746,5 @@
        ELSEIF ( damp_level_1d < 0.0_wp  .OR.  damp_level_1d > zu(nzt+1) )  THEN
           WRITE( message_string, * )  'damp_level_1d = ', damp_level_1d,       &
-                 ' must be > 0.0 and < ', zu(nzt+1), '(zu(nzt+1))'
+                 ' must be >= 0.0 and <= ', zu(nzt+1), '(zu(nzt+1))'
           CALL message( 'check_parameters', 'PA0136', 1, 2, 0, 6, 0 )
        ELSE
@@ -3797,29 +3794,4 @@
        ELSE
           termination_time_needed = 35.0_wp
-       ENDIF
-    ENDIF
-
-!
-!-- Check the time needed to terminate a model run
-    IF ( host(1:3) == 't3e' )  THEN
-!
-!--    Time needed must be at least 30 seconds on all CRAY machines, because
-!--    MPP_TREMAIN gives the remaining CPU time only in steps of 30 seconds
-       IF ( termination_time_needed <= 30.0_wp )  THEN
-          WRITE( message_string, * )  'termination_time_needed = ',            &
-                 termination_time_needed, ' must be > 30.0 on host "',         &
-                 TRIM( host ), '"'
-          CALL message( 'check_parameters', 'PA0139', 1, 2, 0, 6, 0 )
-       ENDIF
-    ELSEIF ( host(1:3) == 'ibm' )  THEN
-!
-!--    On IBM-regatta machines the time should be at least 300 seconds,
-!--    because the job time consumed before executing palm (for compiling,
-!--    copying of files, etc.) has to be regarded
-       IF ( termination_time_needed < 300.0_wp )  THEN
-          WRITE( message_string, * )  'termination_time_needed = ',            &
-                 termination_time_needed, ' should be >= 300.0 on host "',     &
-                 TRIM( host ), '"'
-          CALL message( 'check_parameters', 'PA0140', 1, 2, 0, 6, 0 )
        ENDIF
     ENDIF
@@ -4013,5 +3985,5 @@
           IF ( dt_fixed )  THEN
              WRITE( message_string, '(A,F9.4,A)' )  'Output at every '  //     &
-                    'timestep is desired (' // dt_do_name // ' = 0.0).&'//     &
+                    'timestep is wanted (' // dt_do_name // ' = 0.0).&'//      &
                     'Setting the output interval to the fixed timestep '//     &
                     'dt = ', dt, 's.'
Index: /palm/trunk/SOURCE/data_output_dvrp.f90
===================================================================
--- /palm/trunk/SOURCE/data_output_dvrp.f90	(revision 2273)
+++ /palm/trunk/SOURCE/data_output_dvrp.f90	(revision 2274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Changed error messages
+! 
+! 2101 2017-01-05 16:42:31Z suehring
 !
 ! 2000 2016-08-20 18:09:15Z knoop
@@ -353,5 +356,5 @@
                    ELSE                    
                       message_string = 'if humidity = '    //                  & 
-                            'FALSE output of ' // TRIM( output_variable ) //   &
+                            '.FALSE. output of ' // TRIM( output_variable ) //   &
                             'is not provided' 
                       CALL message( 'data_output_dvrp', 'PA0183',&
@@ -369,5 +372,6 @@
                       ENDDO
                    ELSE                     
-                      message_string = 'if cloud_physics = FALSE '       //    & 
+                      message_string = 'if cloud_physics = .FALSE. and '       //    & 
+                                  'cloud_droplets = .FALSE. '
                                   'output of ' // TRIM( output_variable) //    &
                                   'is not provided' 
@@ -387,5 +391,5 @@
                    ELSE                    
                       message_string = 'if passive_scalar = '    //            & 
-                            'FALSE output of ' // TRIM( output_variable ) //   &
+                            '.FALSE. output of ' // TRIM( output_variable ) //   &
                             'is not provided' 
                       CALL message( 'data_output_dvrp', 'PA0183',&
Index: /palm/trunk/SOURCE/fft_xy_mod.f90
===================================================================
--- /palm/trunk/SOURCE/fft_xy_mod.f90	(revision 2273)
+++ /palm/trunk/SOURCE/fft_xy_mod.f90	(revision 2274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Changed error messages
+! 
+! 2119 2017-01-17 16:51:50Z raasch
 !
 ! 2118 2017-01-17 16:38:49Z raasch
@@ -1793,5 +1796,5 @@
           message_string = 'fft method "' // TRIM( fft_method) // &
                            '" not available'
-          CALL message( 'fft_x_m', 'PA0189', 1, 2, 0, 6, 0 )
+          CALL message( 'fft_y_m', 'PA0189', 1, 2, 0, 6, 0 )
 
        ENDIF
Index: /palm/trunk/SOURCE/init_grid.f90
===================================================================
--- /palm/trunk/SOURCE/init_grid.f90	(revision 2273)
+++ /palm/trunk/SOURCE/init_grid.f90	(revision 2274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Changed error messages
+! 
+! 2233 2017-05-30 18:08:54Z suehring
 !
 ! 2232 2017-05-30 17:47:52Z suehring
@@ -726,5 +729,5 @@
                tunnel_width_y == 9999999.9_wp  )  THEN
              message_string = 'No tunnel width is given. '
-             CALL message( 'init_grid', 'PA0207', 1, 2, 0, 6, 0 )
+             CALL message( 'init_grid', 'PA0280', 1, 2, 0, 6, 0 )
           ENDIF
           IF ( tunnel_width_x /= 9999999.9_wp  .AND.                           &
@@ -733,5 +736,5 @@
                               'tunnel can only be oriented' //                 &
                               'either in x- or in y-direction.'
-             CALL message( 'init_grid', 'PA0207', 1, 2, 0, 6, 0 )
+             CALL message( 'init_grid', 'PA0281', 1, 2, 0, 6, 0 )
           ENDIF
 !
@@ -740,5 +743,5 @@
              IF ( tunnel_width_x > ( nx + 1 ) * dx )  THEN
                 message_string = 'Tunnel width too large'
-                CALL message( 'init_grid', 'PA0207', 1, 2, 0, 6, 0 )
+                CALL message( 'init_grid', 'PA0282', 1, 2, 0, 6, 0 )
              ENDIF
 
@@ -758,10 +761,10 @@
                tunnel_width_x - 2.0_wp * tunnel_wall_depth <= 2.0_wp * dx )  THEN
              message_string = 'Tunnel width too small'
-             CALL message( 'init_grid', 'PA0207', 1, 2, 0, 6, 0 )
+             CALL message( 'init_grid', 'PA0175', 1, 2, 0, 6, 0 )
           ENDIF
           IF ( tunnel_width_y /= 9999999.9_wp  .AND.                           &
                tunnel_width_y - 2.0_wp * tunnel_wall_depth <= 2.0_wp * dy )  THEN
              message_string = 'Tunnel width too small'
-             CALL message( 'init_grid', 'PA0207', 1, 2, 0, 6, 0 )
+             CALL message( 'init_grid', 'PA0455', 1, 2, 0, 6, 0 )
           ENDIF
 !
@@ -770,5 +773,5 @@
              IF ( tunnel_width_y > ( ny + 1 ) * dy )  THEN
                 message_string = 'Tunnel width too large'
-                CALL message( 'init_grid', 'PA0207', 1, 2, 0, 6, 0 )
+                CALL message( 'init_grid', 'PA0456', 1, 2, 0, 6, 0 )
              ENDIF
 
@@ -910,5 +913,5 @@
                       message_string = 'NetCDF attribute lod ' //              &
                                        '(level of detail) is not set properly.'
-                      CALL message( 'init_grid', 'PA0208', 1, 2, 0, 6, 0 ) !Error number still need to be set properly 
+                      CALL message( 'init_grid', 'PA0457', 1, 2, 0, 6, 0 )
                    ENDIF
 !
Index: /palm/trunk/SOURCE/lpm_droplet_collision.f90
===================================================================
--- /palm/trunk/SOURCE/lpm_droplet_collision.f90	(revision 2273)
+++ /palm/trunk/SOURCE/lpm_droplet_collision.f90	(revision 2274)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! ------------------
-!
-!
+! 
+! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Changed error messages
+!
+! 2123 2017-01-18 12:34:59Z hoffmann
 !
 ! 2122 2017-01-18 12:22:54Z hoffmann
@@ -330,5 +333,5 @@
 
           IF ( ANY(weight < 0.0_wp) )  THEN
-                WRITE( message_string, * ) 'negative weighting'
+                WRITE( message_string, * ) 'negative weighting factor'
                 CALL message( 'lpm_droplet_collision', 'PA0028',      &
                                2, 2, -1, 6, 1 )
@@ -498,5 +501,5 @@
 
           IF ( ANY(weight < 0.0_wp) )  THEN
-                WRITE( message_string, * ) 'negative weighting'
+                WRITE( message_string, * ) 'negative weighting factor'
                 CALL message( 'lpm_droplet_collision', 'PA0028',      &
                                2, 2, -1, 6, 1 )
Index: /palm/trunk/SOURCE/lpm_init.f90
===================================================================
--- /palm/trunk/SOURCE/lpm_init.f90	(revision 2273)
+++ /palm/trunk/SOURCE/lpm_init.f90	(revision 2274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+!  Changed error messages
+! 
+! 2265 2017-06-08 16:58:28Z schwenkel
 ! Unused variables removed.
 ! 
@@ -301,5 +304,5 @@
 !-- propably (not realized so far). 
     IF ( surf_def_h(1)%ns >= 1 )  THEN
-       WRITE( message_string, * ) 'Overhanging topograpyh do not work '// &   
+       WRITE( message_string, * ) 'Overhanging topography do not work '// &   
                                   'with particles' 
        CALL message( 'lpm_init', 'PA0212', 0, 1, 0, 6, 0 )
Index: /palm/trunk/SOURCE/plant_canopy_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/plant_canopy_model_mod.f90	(revision 2273)
+++ /palm/trunk/SOURCE/plant_canopy_model_mod.f90	(revision 2274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Changed error messages
+! 
+! 2233 2017-05-30 18:08:54Z suehring
 !
 ! 2232 2017-05-30 17:47:52Z suehring
@@ -301,5 +304,6 @@
 
        IF ( calc_beta_lad_profile  .AND.  lad_surface /= 0.0_wp )  THEN
-          message_string = 'simultaneous setting of alpha_lad /= 9999999.9' // &
+          message_string = 'simultaneous setting of alpha_lad /= 9999999.9 '// &
+                           'combined with beta_lad /= 9999999.9 '           // &
                            'and lad_surface /= 0.0 is not possible, '       // &
                            'use either vertical gradients or the beta '     // &