Index: palm/trunk/SOURCE/surface_layer_fluxes_mod.f90
===================================================================
--- palm/trunk/SOURCE/surface_layer_fluxes_mod.f90	(revision 2233)
+++ palm/trunk/SOURCE/surface_layer_fluxes_mod.f90	(revision 2281)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Clean-up unnecessary index access to surface type
+! 
+! 2233 2017-05-30 18:08:54Z suehring
 !
 ! 2232 2017-05-30 17:47:52Z suehring
@@ -1200,5 +1203,4 @@
              i   = surf%i(m)            
              j   = surf%j(m)
-             k   = surf%k(m)
 
              z_mo = surf%z_mo(m)
@@ -1319,10 +1321,9 @@
        ELSEIF ( TRIM( most_method ) == 'lookup' )  THEN
 
-          !$OMP PARALLEL DO PRIVATE( i, j, k, z_mo, li ) FIRSTPRIVATE( li_bnd ) LASTPRIVATE( li_bnd )
+          !$OMP PARALLEL DO PRIVATE( i, j, z_mo, li ) FIRSTPRIVATE( li_bnd ) LASTPRIVATE( li_bnd )
           DO  m = 1, surf%ns
 
              i   = surf%i(m)            
              j   = surf%j(m)
-             k   = surf%k(m)
 !
 !--          If the bulk Richardson number is outside the range of the lookup
@@ -1461,8 +1462,7 @@
 !--       Compute u* at upward-facing surfaces
           IF ( .NOT. downward )  THEN
-             !$OMP PARALLEL  DO PRIVATE( k, z_mo )
+             !$OMP PARALLEL  DO PRIVATE( z_mo )
              DO  m = 1, surf%ns
 
-                k    = surf%k(m)
                 z_mo = surf%z_mo(m)
 !
@@ -1478,8 +1478,7 @@
 !--       any stability. 
           ELSE
-             !$OMP PARALLEL  DO PRIVATE( k, z_mo )
+             !$OMP PARALLEL  DO PRIVATE( z_mo )
              DO  m = 1, surf%ns
 
-                k    = surf%k(m)
                 z_mo = surf%z_mo(m)
 !
@@ -1611,10 +1610,9 @@
 !--    land-surface model, in order to compute aerodynamical resistance.
        IF ( surf_vertical )  THEN
-          !$OMP PARALLEL DO PRIVATE( i, j, k )
+          !$OMP PARALLEL DO PRIVATE( i, j )
           DO  m = 1, surf%ns 
 
              i          =  surf%i(m)            
              j          =  surf%j(m)
-             k          =  surf%k(m)
              surf%ts(m) = -surf%shf(m) / ( surf%us(m) + 1E-30_wp )
 !
@@ -1713,10 +1711,9 @@
 !--       Compute q* at vertical surfaces
           IF ( surf_vertical )  THEN
-             !$OMP PARALLEL DO PRIVATE( i, j, k )
+             !$OMP PARALLEL DO PRIVATE( i, j )
              DO  m = 1, surf%ns  
 
                 i          =  surf%i(m)            
                 j          =  surf%j(m)
-                k          =  surf%k(m)
                 surf%qs(m) = -surf%qsws(m) / ( surf%us(m) + 1E-30_wp )
 
@@ -1733,9 +1730,8 @@
 !
 !--          For a given scalar flux in the surface layer
-             !$OMP PARALLEL DO PRIVATE( i, j, k )
+             !$OMP PARALLEL DO PRIVATE( i, j )
              DO  m = 1, surf%ns  
                 i   = surf%i(m)            
                 j   = surf%j(m)
-                k   = surf%k(m)
                 surf%ss(m) = -surf%ssws(m) / ( surf%us(m) + 1E-30_wp )
              ENDDO
@@ -1744,9 +1740,8 @@
 !--       At vertical surfaces
           IF ( surf_vertical )  THEN
-             !$OMP PARALLEL DO PRIVATE( i, j, k )
+             !$OMP PARALLEL DO PRIVATE( i, j )
              DO  m = 1, surf%ns  
                 i          =  surf%i(m)            
                 j          =  surf%j(m)
-                k          =  surf%k(m)
                 surf%ss(m) = -surf%ssws(m) / ( surf%us(m) + 1E-30_wp )
              ENDDO
@@ -1924,10 +1919,9 @@
           IF (  .NOT.  constant_scalarflux  .AND.  passive_scalar  .AND.       &
                 .NOT.  downward )  THEN
-             !$OMP PARALLEL DO PRIVATE( i, j, k )
+             !$OMP PARALLEL DO PRIVATE( i, j )
              DO  m = 1, surf%ns   
 
                 i    = surf%i(m)            
                 j    = surf%j(m)
-                k    = surf%k(m)
                 surf%ssws(m) = -surf%ss(m) * surf%us(m)
 
@@ -1938,10 +1932,9 @@
           IF ( cloud_physics  .AND.  microphysics_seifert  .AND.              &
                .NOT. downward)  THEN
-             !$OMP PARALLEL DO PRIVATE( i, j, k )
+             !$OMP PARALLEL DO PRIVATE( i, j )
              DO  m = 1, surf%ns   
 
                 i    = surf%i(m)            
                 j    = surf%j(m)
-                k    = surf%k(m)
 
                 surf%qrsws(m) = -surf%qrs(m) * surf%us(m)
@@ -2050,9 +2043,8 @@
              ENDIF
 
-             !$OMP PARALLEL DO PRIVATE( i, j, k, dum, z_mo )
+             !$OMP PARALLEL DO PRIVATE( i, j, dum, z_mo )
              DO  m = 1, surf%ns  
                 i = surf%i(m)            
                 j = surf%j(m)
-                k = surf%k(m)
 
                 z_mo = surf%z_mo(m)