Index: palm/trunk/SCRIPTS/NCL/profiles.ncl
===================================================================
--- palm/trunk/SCRIPTS/NCL/profiles.ncl	(revision 2296)
+++ palm/trunk/SCRIPTS/NCL/profiles.ncl	(revision 2297)
@@ -2233,10 +2233,10 @@
 	    end if 
 	    
-	    if (nof .EQ. 0) then
-		z_(n,:)=z/norm_z
-		z    = z_(n,:)
-	    else
+	    ;if (nof .EQ. 0) then
+		;z_(n,:)=z/norm_z
+		;z    = z_(n,:)
+	    ;else
 		z=z/norm_z
-	    end if
+	    ;end if
 
 	    delta_z = z(2) - z(1)
Index: palm/trunk/SCRIPTS/mrun
===================================================================
--- palm/trunk/SCRIPTS/mrun	(revision 2296)
+++ palm/trunk/SCRIPTS/mrun	(revision 2297)
@@ -301,5 +301,5 @@
  fftw_lib=""
  fftw_support=false
-  fname=test
+ fname=test
  fromhost=""
  global_revision=""
Index: palm/trunk/SOURCE/time_integration_spinup.f90
===================================================================
--- palm/trunk/SOURCE/time_integration_spinup.f90	(revision 2296)
+++ palm/trunk/SOURCE/time_integration_spinup.f90	(revision 2297)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! bugfixes
+! 
+! 2296 2017-06-28 07:53:56Z maronga
 ! Initial revision
 ! 
@@ -41,5 +44,15 @@
 
     USE control_parameters,                                                    &
-        ONLY:  averaging_interval_pr, constant_diffusion, constant_flux_layer, coupling_start_time, current_timestep_number, data_output_during_spinup, disturbance_created, dopr_n, do_sum, dt_averaging_input_pr, dt_dopr, dt_dots, dt_run_control, dt_spinup, humidity, intermediate_timestep_count, intermediate_timestep_count_max, land_surface, nr_timesteps_this_run, simulated_time, simulated_time_chr, skip_time_dopr, spinup, spinup_pt_amplitude, spinup_pt_mean, spinup_time, timestep_count, timestep_scheme, time_dopr, time_dopr_av, time_dots, time_run_control, time_since_reference_point, urban_surface
+        ONLY:  averaging_interval_pr, constant_diffusion, constant_flux_layer, &
+               coupling_start_time, current_timestep_number,                   &
+               data_output_during_spinup, disturbance_created, dopr_n, do_sum, &
+               dt_averaging_input_pr, dt_dopr, dt_dots, dt_run_control,        &
+               dt_spinup, humidity, intermediate_timestep_count,               &
+               intermediate_timestep_count_max, land_surface,                  &
+               nr_timesteps_this_run, simulated_time, simulated_time_chr,      &
+               skip_time_dopr, spinup, spinup_pt_amplitude, spinup_pt_mean,    &
+               spinup_time, timestep_count, timestep_scheme, time_dopr,        &
+               time_dopr_av, time_dots, time_run_control,                      &
+               time_since_reference_point, urban_surface
 
     USE constants,                                                             &
@@ -71,6 +84,6 @@
         ONLY:  surface_layer_fluxes
 
-    USE surface_mod,                                                        &
-        ONLY :  surf_def_h, surf_def_v, surf_lsm_h, surf_lsm_v, surf_usm_h, &
+    USE surface_mod,                                                           &
+        ONLY :  surf_def_h, surf_def_v, surf_lsm_h, surf_lsm_v, surf_usm_h,    &
                 surf_usm_v
 
@@ -249,5 +262,5 @@
 !--       If required, calculate radiative fluxes and heating rates
           IF ( radiation .AND. intermediate_timestep_count                     &
-               == intermediate_timestep_count_max .AND. simulated_time >    &
+               == intermediate_timestep_count_max .AND. simulated_time >       &
                skip_time_do_radiation )  THEN
 
@@ -337,10 +350,10 @@
 !--    Computation and output of run control parameters.
 !--    This is also done whenever perturbations have been imposed
-       IF ( time_run_control >= dt_run_control  .OR.                     &
-            timestep_scheme(1:5) /= 'runge'  .OR.  disturbance_created ) &
+       IF ( time_run_control >= dt_run_control  .OR.                           &
+            timestep_scheme(1:5) /= 'runge'  .OR.  disturbance_created )       &
        THEN
           CALL run_control
           IF ( time_run_control >= dt_run_control )  THEN
-             time_run_control = MOD( time_run_control, &
+             time_run_control = MOD( time_run_control,                         &
                                      MAX( dt_run_control, dt_spinup ) )
           ENDIF